/*
    Lisans (Türkçe Metin)
    MIT Lisansı (MIT)
    Copyright (c) 2018 tubitak-bilgem-yte

    Hiçbir ücret talep edilmeden burada işbu yazılımın bir kopyasını ve belgelendirme
    dosyalarını (“Yazılım”) elde eden herkese verilen izin; kullanma, kopyalama,
    değiştirme, birleştirme, yayımlama, dağıtma, alt lisanslama, ve/veya yazılımın
    kopyalarını satma eylemleri de dahil olmak üzere ve bununla kısıtlama olmaksızın,
    yazılımın sınırlama olmadan ticaretini yapmak için verilmiş olup, bunları yapmaları
    için yazılımın sağlandığı kişilere aşağıdakileri yapmak koşuluyla sunulur:

    Yukarıdaki telif hakkı bildirimi ve işbu izin bildirimi yazılımın tüm kopyalarına
    veya önemli parçalarına eklenmelidir.

    YAZILIM “HİÇBİR DEĞİŞİKLİK YAPILMADAN” ESASINA BAĞLI OLARAK, TİCARETE ELVERİŞLİLİK,
    ÖZEL BİR AMACA UYGUNLUK VE İHLAL OLMAMASI DA DAHİL VE BUNUNLA KISITLI OLMAKSIZIN
    AÇIKÇA  VEYA ÜSTÜ KAPALI OLARAK HİÇBİR TEMİNAT OLMAKSIZIN SUNULMUŞTUR. HİÇBİR KOŞULDA
    YAZARLAR  VEYA TELİF HAKKI SAHİPLERİ HERHANGİ BİR İDDİAYA, HASARA VEYA DİĞER
    YÜKÜMLÜLÜKLERE KARŞI, YAZILIMLA VEYA KULLANIMLA VEYA YAZILIMIN BAŞKA BAĞLANTILARIYLA
    İLGİLİ, BUNLARDAN KAYNAKLANAN VE BUNLARIN SONUCU BİR SÖZLEŞME DAVASI, HAKSIZ FİİL
    VEYA DİĞER EYLEMLERDEN SORUMLU DEĞİLDİR.

    License (English)
    The MIT License (MIT)
    Copyright (c) 2018 tubitak-bilgem-yte

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the "Software"), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in all
    copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    SOFTWARE.
*/

package controller;

import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.ClientResponse;
import com.sun.jersey.api.client.WebResource;
import com.sun.jersey.api.client.config.ClientConfig;
import com.sun.jersey.api.client.config.DefaultClientConfig;
import com.sun.jersey.api.json.JSONConfiguration;

import model.Sonuc;

public class Program {
	/* Gercek sisteme entegre olmak icin utstest yerine utsuygulama yazilmalidir */
	private final static String url = "https://utstest.saglik.gov.tr";

	/* utstest veya utsuygulama'ya giris yapip Kullanici > Sistem Kullanicisi Tanimlama Islemleri
	*  menusunden alinan token asagida utsToken olarak ayarlanmalidir */
	private final static String utsToken = "";
	
	public static void main(String[] args) {
		Program program = new Program();

		/* Asagida su bildirim parametreleri ayarlanmaktadir: urunNumarasi, seriNumarasi, belgeNumarasi, kurumNumarasi
		   Bunlarin yerine uygun degerleri girmelisiniz. */

		// Urun Numarasi, Barkod Numarasi, Urun Karti uzerindeki numara
		String urunNumarasi = "";
		// Urunun seri numarasi
		String seriNumarasi = "";
		// tekil urunun uretim tarihi YYYY-MM-DD seklinde olmalidir. Ornegin 2017-09-13 gibi.
		String uretimTarihi = "";
		// Verme islemine iliskin duzenlenen belge numarasi, ornegin irsaliye numarasi.
		String belgeNumarasi = "";
		// Verme yapilacak kurumun UBB numarasi numarasi
		Long kurumNumarasi = -1L;

		/* asagida once uretim sonra verme bildirimi yapilmaktadir. */
		program.uretimBildirimiEkle(urunNumarasi,seriNumarasi, uretimTarihi);
		program.vermeBildirimiYap(urunNumarasi,seriNumarasi, belgeNumarasi, kurumNumarasi);
	}
	
	public void uretimBildirimiEkle( final String urunNumarasi,
									 final String seriNumarasi,
									 final String uretimTarihi){
		try {

			ClientConfig clientConfig = new DefaultClientConfig();
			clientConfig.getFeatures().put(JSONConfiguration.FEATURE_POJO_MAPPING, Boolean.TRUE);
			Client client = Client.create(clientConfig);
			
			String resource = "/UTS/uh/rest/bildirim/uretim/ekle";			
			WebResource webResource = client.resource( url + resource );
			
			String input = "{"
					+ "\"UNO\":\"" + urunNumarasi + "\","
					+ "\"SNO\":\"" + seriNumarasi + "\","
					+ "\"URT\":\"" + uretimTarihi + "\""
					+ "}";

			ClientResponse response = webResource.accept("application/json")
					.type("application/json")
					.header("utsToken", utsToken)
					.post(ClientResponse.class, input);

			if (response.getStatus() != 200) {
				throw new RuntimeException("Failed : HTTP error code : " + response.getStatus());
			}

			Sonuc sonuc = response.getEntity(Sonuc.class);

			System.out.println("SNC:" + sonuc.getSNC());
            System.out.println("MET:" + sonuc.getMSJ().get(0).getMET());
            System.out.println("KOD:" + sonuc.getMSJ().get(0).getKOD());
            System.out.println("TIP:" + sonuc.getMSJ().get(0).getTIP());

		} catch (Exception e) {

			e.printStackTrace();

		}
	}
	
	public void vermeBildirimiYap(  final String urunNumarasi, 
									final String seriNumarasi, 
									final String belgeNumarasi, 
									final Long kurumNumarasi ){
		try {

			ClientConfig clientConfig = new DefaultClientConfig();
			clientConfig.getFeatures().put(JSONConfiguration.FEATURE_POJO_MAPPING, Boolean.TRUE);
			Client client = Client.create(clientConfig);
			
			String resource = "/UTS/uh/rest/bildirim/verme/ekle";			
			WebResource webResource = client.resource( url + resource );
			
			String input = "{"
					+ "\"UNO\":\"" + urunNumarasi + "\","
					+ "\"SNO\":\"" + seriNumarasi + "\","
					+ "\"BNO\":\"" + belgeNumarasi + "\","
					+ "\"KUN\":" + kurumNumarasi
					+ "}";

			ClientResponse response = webResource.accept("application/json")
					.type("application/json")
					.header("utsToken", utsToken)
					.post(ClientResponse.class, input);

			if (response.getStatus() != 200) {
				throw new RuntimeException("Failed : HTTP error code : " + response.getStatus());
			}

			Sonuc sonuc = response.getEntity(Sonuc.class);

			System.out.println("SNC:" + sonuc.getSNC());
            System.out.println("MET:" + sonuc.getMSJ().get(0).getMET());
            System.out.println("KOD:" + sonuc.getMSJ().get(0).getKOD());
            System.out.println("TIP:" + sonuc.getMSJ().get(0).getTIP());

		} catch (Exception e) {

			e.printStackTrace();

		}
	}

}